Index: src/libcfa/prelude.cf
===================================================================
--- src/libcfa/prelude.cf	(revision f0663213735198062b3ba689b56f1f8d441722e9)
+++ src/libcfa/prelude.cf	(revision 77acda0647ee049631d1941967698fc4c9139984)
@@ -7,7 +7,7 @@
 // Author           : Glen Ditchfield
 // Created On       : Sat Nov 29 07:23:41 2014
-// Last Modified By : Rob Schluntz
-// Last Modified On : Thu Nov 19 11:09:47 2015
-// Update Count     : 76
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Mon Jan  4 11:13:26 2016
+// Update Count     : 81
 //
 
@@ -149,7 +149,7 @@
 unsigned int		?*?( unsigned int, unsigned int ),			?/?( unsigned int, unsigned int ),		?%?( unsigned int, unsigned int );
 signed long int		?*?( signed long int, signed long int ),		?/?( signed long int, signed long int ),	?%?( signed long int, signed long int );
-unsigned long int	?*?( unsigned long int, unsigned long int ),		?/?( unsigned long int, long unsigned ),	?%?( long unsigned, long unsigned );
+unsigned long int	?*?( unsigned long int, unsigned long int ),		?/?( unsigned long int, unsigned long int ),	?%?( unsigned long int, unsigned long int );
 signed long long int	?*?( signed long long int, signed long long int ),	?/?( signed long long int, signed long long int ), ?%?( signed long long int, signed long long int );
-unsigned long long int	?*?( unsigned long long int, unsigned long long int ),	?/?( unsigned long long int, long long unsigned ), ?%?( long long unsigned, long long unsigned );
+unsigned long long int	?*?( unsigned long long int, unsigned long long int ),	?/?( unsigned long long int, unsigned long long int ), ?%?( unsigned long long int, unsigned long long int );
 float			?*?( float, float ),					?/?( float, float );
 double			?*?( double, double ),					?/?( double, double );
@@ -173,7 +173,7 @@
 unsigned int		?+?( unsigned int, unsigned int ),			?-?( unsigned int, unsigned int );
 signed long int		?+?( signed long int, signed long int ),		?-?( signed long int, signed long int );
-unsigned long int	?+?( unsigned long int, unsigned long int ),		?-?( unsigned long int, long unsigned );
+unsigned long int	?+?( unsigned long int, unsigned long int ),		?-?( unsigned long int, unsigned long int );
 signed long long int	?+?( signed long long int, long long int  signed),	?-?( signed long long int, signed long long int );
-unsigned long long int	?+?( unsigned long long int, unsigned long long int ),	?-?( unsigned long long int, long long unsigned );
+unsigned long long int	?+?( unsigned long long int, unsigned long long int ),	?-?( unsigned long long int, unsigned long long int );
 float			?+?( float, float ),					?-?( float, float );
 double			?+?( double, double ),					?-?( double, double );
@@ -203,9 +203,11 @@
 // ------------------------------------------------------------
 
-_Bool			?<<?( _Bool, _Bool ),				?>>?( _Bool, _Bool );
-signed int		?<<?( signed int, signed int ),			?>>?( signed int, signed int );
-unsigned int		?<<?( unsigned int, unsigned int ),		?>>?( unsigned int, unsigned int );
-signed long int		?<<?( signed long int, signed long int ),	?>>?( signed long int, signed long int );
-unsigned long int	?<<?( unsigned long int, long unsigned ),	?>>?( unsigned long int, unsigned long int );
+_Bool			?<<?( _Bool, _Bool ),					?>>?( _Bool, _Bool );
+signed int		?<<?( signed int, signed int ),				?>>?( signed int, signed int );
+unsigned int		?<<?( unsigned int, unsigned int ),			?>>?( unsigned int, unsigned int );
+signed long int		?<<?( signed long int, signed long int ),		?>>?( signed long int, signed long int );
+unsigned long int	?<<?( unsigned long int, unsigned long int ),		?>>?( unsigned long int, unsigned long int );
+signed long long int	?<<?( signed long long int, signed long long int ),	?>>?( signed long long int, signed long long int );
+unsigned long long int	?<<?( unsigned long long int, unsigned long long int ),	?>>?( unsigned long long int, unsigned long long int );
 
 // ------------------------------------------------------------
@@ -215,22 +217,26 @@
 // ------------------------------------------------------------
 
-signed int ?<?( _Bool, _Bool ),				?<=?( _Bool, _Bool ),
-	   ?>?( _Bool, _Bool ),				?>=?( _Bool, _Bool );
-signed int ?<?( unsigned char, unsigned char ),		?<=?( unsigned char, unsigned char ),
-	   ?>?( unsigned char, unsigned char ),		?>=?( unsigned char, unsigned char );
-signed int ?<?( signed int, signed int ),		?<=?( signed int, signed int ),
-	   ?>?( signed int, signed int ),		?>=?( signed int, signed int );
-signed int ?<?( unsigned int, unsigned int ),		?<=?( unsigned int, unsigned int ),
-	   ?>?( unsigned int, unsigned int ),		?>=?( unsigned int, unsigned int );
-signed int ?<?( signed long int, signed long int ),	?<=?( signed long int, signed long int ),
-	   ?>?( signed long int, signed long int ),	?>=?( signed long int, signed long int );
-signed int ?<?( unsigned long int, unsigned long int ),	?<=?( unsigned long int, unsigned long int ),
-	   ?>?( unsigned long int, unsigned long int ),	?>=?( unsigned long int, unsigned long int );
-signed int ?<?( float, float ),				?<=?( float, float ),
-	   ?>?( float, float ),				?>=?( float, float );
-signed int ?<?( double, double ),			?<=?( double, double ),
-	   ?>?( double, double ),			?>=?( double, double );
-signed int ?<?( long double, long double ),		?<=?( long double, long double ),
-	   ?>?( long double, long double ),		?>=?( long double, long double );
+signed int ?<?( _Bool, _Bool ),						?<=?( _Bool, _Bool ),
+	   ?>?( _Bool, _Bool ),						?>=?( _Bool, _Bool );
+signed int ?<?( unsigned char, unsigned char ),				?<=?( unsigned char, unsigned char ),
+	   ?>?( unsigned char, unsigned char ),				?>=?( unsigned char, unsigned char );
+signed int ?<?( signed int, signed int ),				?<=?( signed int, signed int ),
+	   ?>?( signed int, signed int ),				?>=?( signed int, signed int );
+signed int ?<?( unsigned int, unsigned int ),				?<=?( unsigned int, unsigned int ),
+	   ?>?( unsigned int, unsigned int ),				?>=?( unsigned int, unsigned int );
+signed int ?<?( signed long int, signed long int ),			?<=?( signed long int, signed long int ),
+	   ?>?( signed long int, signed long int ),			?>=?( signed long int, signed long int );
+signed int ?<?( unsigned long int, unsigned long int ),			?<=?( unsigned long int, unsigned long int ),
+	   ?>?( unsigned long int, unsigned long int ),			?>=?( unsigned long int, unsigned long int );
+signed int ?<?( signed long long int, signed long long int ),		?<=?( signed long long int, signed long long int ),
+	   ?>?( signed long long int, signed long long int ),		?>=?( signed long long int, signed long long int );
+signed int ?<?( unsigned long long int, unsigned long long int ),	?<=?( unsigned long long int, unsigned long long int ),
+	   ?>?( unsigned long long int, unsigned long long int ),	?>=?( unsigned long long int, unsigned long long int );
+signed int ?<?( float, float ),						?<=?( float, float ),
+	   ?>?( float, float ),						?>=?( float, float );
+signed int ?<?( double, double ),					?<=?( double, double ),
+	   ?>?( double, double ),					?>=?( double, double );
+signed int ?<?( long double, long double ),				?<=?( long double, long double ),
+	   ?>?( long double, long double ),				?>=?( long double, long double );
 
 forall( dtype DT ) signed int ?<?(  const volatile DT *, const volatile DT * );
@@ -245,17 +251,17 @@
 // ------------------------------------------------------------
 
-signed int ?==?( _Bool, _Bool ),				?!=?( _Bool, _Bool );
-signed int ?==?( signed int, signed int ),			?!=?( signed int, signed int );
-signed int ?==?( unsigned int, unsigned int ),			?!=?( unsigned int, unsigned int );
-signed int ?==?( signed long int, signed long int ),		?!=?( signed long int, signed long int );
-signed int ?==?( unsigned long int, unsigned long int ),	?!=?( unsigned long int, long unsigned );
-signed int ?==?( signed long long int, long long int  signed),	?!=?( signed long long int, signed long long int );
-signed int ?==?( unsigned long long int, unsigned long long int ), ?!=?( unsigned long long int, long long unsigned );
-signed int ?==?( float, float ),				?!=?( float, float );
-signed int ?==?( double, double ),				?!=?( double, double );
-signed int ?==?( long double, long double ),			?!=?( long double, long double );
-signed int ?==?( float _Complex, float _Complex ),		?!=?( float _Complex, float _Complex );
-signed int ?==?( double _Complex, double _Complex ),		?!=?( double _Complex, double _Complex );
-signed int ?==?( long double _Complex, long double _Complex ),	?!=?( long double _Complex, long double _Complex );
+signed int ?==?( _Bool, _Bool ),					?!=?( _Bool, _Bool );
+signed int ?==?( signed int, signed int ),				?!=?( signed int, signed int );
+signed int ?==?( unsigned int, unsigned int ),				?!=?( unsigned int, unsigned int );
+signed int ?==?( signed long int, signed long int ),			?!=?( signed long int, signed long int );
+signed int ?==?( unsigned long int, unsigned long int ),		?!=?( unsigned long int, unsigned long int );
+signed int ?==?( signed long long int, long long int  signed),		?!=?( signed long long int, signed long long int );
+signed int ?==?( unsigned long long int, unsigned long long int ),	?!=?( unsigned long long int, unsigned long long int );
+signed int ?==?( float, float ),					?!=?( float, float );
+signed int ?==?( double, double ),					?!=?( double, double );
+signed int ?==?( long double, long double ),				?!=?( long double, long double );
+signed int ?==?( float _Complex, float _Complex ),			?!=?( float _Complex, float _Complex );
+signed int ?==?( double _Complex, double _Complex ),			?!=?( double _Complex, double _Complex );
+signed int ?==?( long double _Complex, long double _Complex ),		?!=?( long double _Complex, long double _Complex );
 
 forall( dtype DT ) signed int ?==?(		   DT *,		DT * );
@@ -295,4 +301,6 @@
 signed long int		?&?( signed long int, signed long int );
 unsigned long int	?&?( unsigned long int, unsigned long int );
+signed long long int	?&?( signed long long int, signed long long int );
+unsigned long long int	?&?( unsigned long long int, unsigned long long int );
 
 // ------------------------------------------------------------
@@ -307,4 +315,6 @@
 signed long int		?^?( signed long int, signed long int );
 unsigned long int	?^?( unsigned long int, unsigned long int );
+signed long long int	?^?( signed long long int, signed long long int );
+unsigned long long int	?^?( unsigned long long int, unsigned long long int );
 
 // ------------------------------------------------------------
@@ -319,4 +329,6 @@
 signed long int		?|?( signed long int, signed long int );
 unsigned long int	?|?( unsigned long int, unsigned long int );
+signed long long int	?|?( signed long long int, signed long long int );
+unsigned long long int	?|?( unsigned long long int, unsigned long long int );
 
 // ------------------------------------------------------------